# Interface ServletContext

public interface ServletContext
Defines a set of methods that a servlet uses to communicate with its servlet container, for example, to get the MIME type of a file, dispatch requests, or write to a log file.

There is one context per "web application" per Java Virtual Machine. (A "web application" is a collection of servlets and content installed under a specific subset of the server's URL namespace such as `/catalog` and possibly installed via a `.war` file.)

In the case of a web application marked "distributed" in its deployment descriptor, there will be one context instance for each virtual machine. In this situation, the context cannot be used as a location to share global information (because the information won't be truly global). Use an external resource like a database instead.

The `ServletContext` object is contained within the `ServletConfig` object, which the Web server provides the servlet when the servlet is initialized.

See Also:
  - `Servlet.getServletConfig()`
  - `ServletConfig.getServletContext()`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`ORDERED_LIBS`
The name of the ServletContext attribute that holds the ordered list of web fragments for this web application.
`static final String`
`TEMPDIR`
The name of the ServletContext attribute that holds the temporary file location for the web application.

## Method Summary

Modifier and Type
Method
Description
`FilterRegistration.Dynamic`
`addFilter(String filterName, Filter filter)`
Add filter to context.
`FilterRegistration.Dynamic`
`addFilter(String filterName, Class<? extends Filter> filterClass)`
Add filter to context.
`FilterRegistration.Dynamic`
`addFilter(String filterName, String className)`
Add filter to context.
`ServletRegistration.Dynamic`
`addJspFile(String jspName, String jspFile)`
Add a JSP to the context.
`void`
`addListener(Class<? extends EventListener> listenerClass)`
Adds a listener to this web application.
`void`
`addListener(String className)`
Adds a listener to this web application.
`<T extends EventListener>
void`
`addListener(T t)`
Adds the given listener instance to this web application.
`ServletRegistration.Dynamic`
`addServlet(String servletName, Servlet servlet)`
Register a servlet instance for use in this ServletContext.
`ServletRegistration.Dynamic`
`addServlet(String servletName, Class<? extends Servlet> servletClass)`
Add servlet to the context.
`ServletRegistration.Dynamic`
`addServlet(String servletName, String className)`
Register a servlet implementation for use in this ServletContext.
`<T extends Filter>
T`
`createFilter(Class<T> c)`
Create a Filter instance using the given class.
`<T extends EventListener>
T`
`createListener(Class<T> c)`
Creates a new instance of the given listener class, using the web application class loader.
`<T extends Servlet>
T`
`createServlet(Class<T> c)`
Create an Servlet instance using the given class.
`void`
`declareRoles(String... roleNames)`
Add to the declared roles for this ServletContext.
`Object`
`getAttribute(String name)`
Returns the servlet container attribute with the given name, or `null` if there is no attribute by that name.
`Enumeration<String>`
`getAttributeNames()`
Returns an `Enumeration` containing the attribute names available within this servlet context.
`ClassLoader`
`getClassLoader()`
Get the web application class loader associated with this ServletContext.
`ServletContext`
`getContext(String uripath)`
Returns a `ServletContext` object that corresponds to a specified URL on the server.
`String`
`getContextPath()`
Return the main path associated with this context.
`Set<SessionTrackingMode>`
`getDefaultSessionTrackingModes()`
Obtains the default session tracking modes for this web application.
`int`
`getEffectiveMajorVersion()`
Obtain the major version of the servlet specification for which this web application is implemented.
`int`
`getEffectiveMinorVersion()`
Obtain the minor version of the servlet specification for which this web application is implemented.
`Set<SessionTrackingMode>`
`getEffectiveSessionTrackingModes()`
Obtains the currently enabled session tracking modes for this web application.
`FilterRegistration`
`getFilterRegistration(String filterName)`
Returns the `FilterRegistration` for the given filter, or `null` if no such filter exists.
`Map<String, ? extends FilterRegistration>`
`getFilterRegistrations()`
Returns an immutable Map of all the filter registrations for this web application, where the key is the filter name and the value is the `FilterRegistration` object.
`String`
`getInitParameter(String name)`
Returns a `String` containing the value of the named context-wide initialization parameter, or `null` if the parameter does not exist.
`Enumeration<String>`
`getInitParameterNames()`
Returns the names of the context's initialization parameters as an `Enumeration` of `String` objects, or an empty `Enumeration` if the context has no initialization parameters.
`JspConfigDescriptor`
`getJspConfigDescriptor()`
Returns the `JspConfigDescriptor` for this web application, which provides access to the JSP configuration elements such as taglib and jsp-property-group declarations.
`int`
`getMajorVersion()`
Returns the major version of the Java Servlet API that this servlet container supports.
`String`
`getMimeType(String file)`
Returns the MIME type of the specified file, or `null` if the MIME type is not known.
`int`
`getMinorVersion()`
Returns the minor version of the Servlet API that this servlet container supports.
`RequestDispatcher`
`getNamedDispatcher(String name)`
Returns a `RequestDispatcher` object that acts as a wrapper for the named servlet.
`String`
`getRealPath(String path)`
Returns a `String` containing the real path for a given virtual path.
`String`
`getRequestCharacterEncoding()`
Get the default character encoding for reading request bodies.
`RequestDispatcher`
`getRequestDispatcher(String path)`
Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path.
`URL`
`getResource(String path)`
Returns a URL to the resource that is mapped to a specified path.
`InputStream`
`getResourceAsStream(String path)`
Returns the resource located at the named path as an `InputStream` object.
`Set<String>`
`getResourcePaths(String path)`
Returns a directory-like listing of all the paths to resources within the web application whose longest sub-path matches the supplied path argument.
`String`
`getResponseCharacterEncoding()`
Get the default character encoding for writing response bodies.
`String`
`getServerInfo()`
Returns the name and version of the servlet container on which the servlet is running.
`String`
`getServletContextName()`
Returns the name of this web application corresponding to this ServletContext as specified in the deployment descriptor for this web application by the display-name element.
`ServletRegistration`
`getServletRegistration(String servletName)`
Obtain the details of the named servlet.
`Map<String, ? extends ServletRegistration>`
`getServletRegistrations()`
Obtain a Map of servlet names to servlet registrations for all servlets registered with this context.
`SessionCookieConfig`
`getSessionCookieConfig()`
Returns the `SessionCookieConfig` object for this web application, which can be used to configure the session tracking cookie.
`int`
`getSessionTimeout()`
Get the default session timeout.
`String`
`getVirtualServerName()`
Get the primary name of the virtual host on which this context is deployed.
`void`
`log(String msg)`
Writes the specified message to a servlet log file, usually an event log.
`void`
`log(String message, Throwable throwable)`
Writes an explanatory message and a stack trace for a given `Throwable` exception to the servlet log file.
`void`
`removeAttribute(String name)`
Removes the attribute with the given name from the servlet context.
`void`
`setAttribute(String name, Object object)`
Binds an object to a given attribute name in this servlet context.
`boolean`
`setInitParameter(String name, String value)`
Set the given initialisation parameter to the given value.
`void`
`setRequestCharacterEncoding(String encoding)`
Set the default character encoding to use for reading request bodies.
`void`
`setResponseCharacterEncoding(String encoding)`
Set the default character encoding to use for writing response bodies.
`void`
`setSessionTimeout(int sessionTimeout)`
Set the default session timeout.
`void`
`setSessionTrackingModes(Set<SessionTrackingMode> sessionTrackingModes)`
Configures the available session tracking modes for this web application.

## Field Details

### TEMPDIR

static final String TEMPDIR
The name of the ServletContext attribute that holds the temporary file location for the web application.

See Also:
  - Constant Field Values

### ORDERED_LIBS

static final String ORDERED_LIBS
The name of the ServletContext attribute that holds the ordered list of web fragments for this web application.

Since:
  Servlet 3.0
See Also:
  - Constant Field Values

## Method Details

### getContextPath

String getContextPath()
Return the main path associated with this context.

Returns:
  The main context path
Since:
  Servlet 2.5

### getContext

ServletContext getContext(String uripath)
Returns a `ServletContext` object that corresponds to a specified URL on the server.

This method allows servlets to gain access to the context for various parts of the server, and as needed obtain `RequestDispatcher` objects from the context. The given path must be begin with "/", is interpreted relative to the server's document root and is matched against the context roots of other web applications hosted on this container.

In a security conscious environment, the servlet container may return `null` for a given URL.

Parameters:
  `uripath` - a `String` specifying the context path of another web application in the container.
Returns:
  the `ServletContext` object that corresponds to the named URL, or null if either none exists or the container wishes to restrict this access.
See Also:
  - `RequestDispatcher`

### getMajorVersion

int getMajorVersion()
Returns the major version of the Java Servlet API that this servlet container supports. All implementations that comply with Version 6.0 must have this method return the integer 6.

Returns:
  6

### getMinorVersion

int getMinorVersion()
Returns the minor version of the Servlet API that this servlet container supports. All implementations that comply with Version 6.0 must have this method return the integer 0.

Returns:
  0

### getEffectiveMajorVersion

int getEffectiveMajorVersion()
Obtain the major version of the servlet specification for which this web application is implemented.

Returns:
  The major version declared in web.xml
Since:
  Servlet 3.0

### getEffectiveMinorVersion

int getEffectiveMinorVersion()
Obtain the minor version of the servlet specification for which this web application is implemented.

Returns:
  The minor version declared in web.xml
Since:
  Servlet 3.0

### getMimeType

String getMimeType(String file)
Returns the MIME type of the specified file, or `null` if the MIME type is not known. The MIME type is determined by the configuration of the servlet container, and may be specified in a web application deployment descriptor. Common MIME types are `"text/html"` and `"image/gif"`.

Parameters:
  `file` - a `String` specifying the name of a file
Returns:
  a `String` specifying the file's MIME type

### getResourcePaths

Set<String> getResourcePaths(String path)
Returns a directory-like listing of all the paths to resources within the web application whose longest sub-path matches the supplied path argument. Paths indicating subdirectory paths end with a '/'. The returned paths are all relative to the root of the web application and have a leading '/'. For example, for a web application containing
/welcome.html
/catalog/index.html
/catalog/products.html
/catalog/offers/books.html
/catalog/offers/music.html
/customer/login.jsp
/WEB-INF/web.xml
/WEB-INF/classes/com.acme.OrderServlet.class,
getResourcePaths("/") returns {"/welcome.html", "/catalog/", "/customer/", "/WEB-INF/"}
getResourcePaths("/catalog/") returns {"/catalog/index.html", "/catalog/products.html", "/catalog/offers/"}.

Parameters:
  `path` - the partial path used to match the resources, which must start with a /
Returns:
  a Set containing the directory listing, or null if there are no resources in the web application whose path begins with the supplied path.
Since:
  Servlet 2.3

### getResource

URL getResource(String path) throws MalformedURLException
Returns a URL to the resource that is mapped to a specified path. The path must begin with a "/" and is interpreted as relative to the current context root.

This method allows the servlet container to make a resource available to servlets from any source. Resources can be located on a local or remote file system, in a database, or in a `.war` file.

The servlet container must implement the URL handlers and `URLConnection` objects that are necessary to access the resource.

This method returns `null` if no resource is mapped to the pathname.

Some containers may allow writing to the URL returned by this method using the methods of the URL class.

The resource content is returned directly, so be aware that requesting a `.jsp` page returns the JSP source code. Use a `RequestDispatcher` instead to include results of an execution.

This method has a different purpose than `java.lang.Class.getResource`, which looks up resources based on a class loader. This method does not use class loaders.

Parameters:
  `path` - a `String` specifying the path to the resource
Returns:
  the resource located at the named path, or `null` if there is no resource at that path
Throws:
  `MalformedURLException` - if the pathname is not given in the correct form

### getResourceAsStream

InputStream getResourceAsStream(String path)
Returns the resource located at the named path as an `InputStream` object.

The data in the `InputStream` can be of any type or length. The path must be specified according to the rules given in `getResource`. This method returns `null` if no resource exists at the specified path.

Meta-information such as content length and content type that is available via `getResource` method is lost when using this method.

The servlet container must implement the URL handlers and `URLConnection` objects necessary to access the resource.

This method is different from `java.lang.Class.getResourceAsStream`, which uses a class loader. This method allows servlet containers to make a resource available to a servlet from any location, without using a class loader.

Parameters:
  `path` - a `String` specifying the path to the resource
Returns:
  the `InputStream` returned to the servlet, or `null` if no resource exists at the specified path

### getRequestDispatcher

RequestDispatcher getRequestDispatcher(String path)
Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path. A `RequestDispatcher` object can be used to forward a request to the resource or to include the resource in a response. The resource can be dynamic or static.

The pathname must begin with a "/" and is interpreted as relative to the current context root. Use `getContext` to obtain a `RequestDispatcher` for resources in foreign contexts. This method returns `null` if the `ServletContext` cannot return a `RequestDispatcher`.

Parameters:
  `path` - a `String` specifying the pathname to the resource
Returns:
  a `RequestDispatcher` object that acts as a wrapper for the resource at the specified path, or `null` if the `ServletContext` cannot return a `RequestDispatcher`
See Also:
  - `RequestDispatcher`
  - `getContext(String)`

### getNamedDispatcher

RequestDispatcher getNamedDispatcher(String name)
Returns a `RequestDispatcher` object that acts as a wrapper for the named servlet.

Servlets (and JSP pages also) may be given names via server administration or via a web application deployment descriptor. A servlet instance can determine its name using `ServletConfig.getServletName()`.

This method returns `null` if the `ServletContext` cannot return a `RequestDispatcher` for any reason.

Parameters:
  `name` - a `String` specifying the name of a servlet to wrap
Returns:
  a `RequestDispatcher` object that acts as a wrapper for the named servlet, or `null` if the `ServletContext` cannot return a `RequestDispatcher`
See Also:
  - `RequestDispatcher`
  - `getContext(String)`
  - `ServletConfig.getServletName()`

### log

void log(String msg)
Writes the specified message to a servlet log file, usually an event log. The name and type of the servlet log file is specific to the servlet container.

Parameters:
  `msg` - a `String` specifying the message to be written to the log file

### log

void log(String message, Throwable throwable)
Writes an explanatory message and a stack trace for a given `Throwable` exception to the servlet log file. The name and type of the servlet log file is specific to the servlet container, usually an event log.

Parameters:
  `message` - a `String` that describes the error or exception
  `throwable` - the `Throwable` error or exception

### getRealPath

String getRealPath(String path)
Returns a `String` containing the real path for a given virtual path. For example, the path "/index.html" returns the absolute file path on the server's filesystem would be served by a request for "http://host/contextPath/index.html", where contextPath is the context path of this ServletContext..

The real path returned will be in a form appropriate to the computer and operating system on which the servlet container is running, including the proper path separators. This method returns `null` if the servlet container cannot translate the virtual path to a real path for any reason (such as when the content is being made available from a `.war` archive).

Parameters:
  `path` - a `String` specifying a virtual path
Returns:
  a `String` specifying the real path, or null if the translation cannot be performed

### getServerInfo

String getServerInfo()
Returns the name and version of the servlet container on which the servlet is running.

The form of the returned string is servername/versionnumber. For example, the JavaServer Web Development Kit may return the string `JavaServer Web Dev Kit/1.0`.

The servlet container may return other optional information after the primary string in parentheses, for example, `JavaServer Web Dev Kit/1.0 (JDK 1.1.6; Windows NT 4.0 x86)`.

Returns:
  a `String` containing at least the servlet container name and version number

### getInitParameter

String getInitParameter(String name)
Returns a `String` containing the value of the named context-wide initialization parameter, or `null` if the parameter does not exist.

This method can make available configuration information useful to an entire "web application". For example, it can provide a web site administrator's email address or the name of a system that holds critical data.

Parameters:
  `name` - a `String` containing the name of the parameter whose value is requested
Returns:
  a `String` containing the value of the initialization parameter
Throws:
  `NullPointerException` - If the provided parameter name is `null`
See Also:
  - `ServletConfig.getInitParameter(String)`

### getInitParameterNames

Enumeration<String> getInitParameterNames()
Returns the names of the context's initialization parameters as an `Enumeration` of `String` objects, or an empty `Enumeration` if the context has no initialization parameters.

Returns:
  an `Enumeration` of `String` objects containing the names of the context's initialization parameters
See Also:
  - `ServletConfig.getInitParameter(String)`

### setInitParameter

boolean setInitParameter(String name, String value)
Set the given initialisation parameter to the given value.

Parameters:
  `name` - Name of initialisation parameter
  `value` - Value for initialisation parameter
Returns:
  `true` if the call succeeds or `false` if the call fails because an initialisation parameter with the same name has already been set
Throws:
  `IllegalStateException` - If initialisation of this ServletContext has already completed
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
  `NullPointerException` - If the provided parameter name is `null`
Since:
  Servlet 3.0

### getAttribute

Object getAttribute(String name)
Returns the servlet container attribute with the given name, or `null` if there is no attribute by that name. An attribute allows a servlet container to give the servlet additional information not already provided by this interface. See your server documentation for information about its attributes. A list of supported attributes can be retrieved using `getAttributeNames`.

The attribute is returned as a `java.lang.Object` or some subclass. Attribute names should follow the same convention as package names. The Jakarta EE platform reserves names matching `jakarta.*`.

Parameters:
  `name` - a `String` specifying the name of the attribute
Returns:
  an `Object` containing the value of the attribute, or `null` if no attribute exists matching the given name
Throws:
  `NullPointerException` - If the provided attribute name is `null`
See Also:
  - `getAttributeNames()`

### getAttributeNames

Enumeration<String> getAttributeNames()
Returns an `Enumeration` containing the attribute names available within this servlet context. Use the `getAttribute(String)` method with an attribute name to get the value of an attribute.

Returns:
  an `Enumeration` of attribute names
See Also:
  - `getAttribute(String)`

### setAttribute

void setAttribute(String name, Object object)
Binds an object to a given attribute name in this servlet context. If the name specified is already used for an attribute, this method will replace the attribute with the new to the new attribute.

If listeners are configured on the `ServletContext` the container notifies them accordingly.

If a null value is passed, the effect is the same as calling `removeAttribute()`.

Attribute names should follow the same convention as package names. The Jakarta EE platform reserves names matching `jakarta.*`.

Parameters:
  `name` - a `String` specifying the name of the attribute
  `object` - an `Object` representing the attribute to be bound
Throws:
  `NullPointerException` - If the provided attribute name is `null`

### removeAttribute

void removeAttribute(String name)
Removes the attribute with the given name from the servlet context. After removal, subsequent calls to `getAttribute(String)` to retrieve the attribute's value will return `null`.

If listeners are configured on the `ServletContext` the container notifies them accordingly.

Parameters:
  `name` - a `String` specifying the name of the attribute to be removed

### getServletContextName

String getServletContextName()
Returns the name of this web application corresponding to this ServletContext as specified in the deployment descriptor for this web application by the display-name element.

Returns:
  The name of the web application or null if no name has been declared in the deployment descriptor.
Since:
  Servlet 2.3

### addServlet

ServletRegistration.Dynamic addServlet(String servletName, String className)
Register a servlet implementation for use in this ServletContext.

Parameters:
  `servletName` - The name of the servlet to register
  `className` - The implementation class for the servlet
Returns:
  The registration object that enables further configuration
Throws:
  `IllegalStateException` - If the context has already been initialised
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### addServlet

ServletRegistration.Dynamic addServlet(String servletName, Servlet servlet)
Register a servlet instance for use in this ServletContext.

Parameters:
  `servletName` - The name of the servlet to register
  `servlet` - The Servlet instance to register
Returns:
  The registration object that enables further configuration
Throws:
  `IllegalStateException` - If the context has already been initialised
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### addServlet

ServletRegistration.Dynamic addServlet(String servletName, Class<? extends Servlet> servletClass)
Add servlet to the context.

Parameters:
  `servletName` - Name of servlet to add
  `servletClass` - Class of servlet to add
Returns:
  `null` if the servlet has already been fully defined, else a `ServletRegistration.Dynamic` object that can be used to further configure the servlet
Throws:
  `IllegalStateException` - If the context has already been initialised
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### addJspFile

ServletRegistration.Dynamic addJspFile(String jspName, String jspFile)
Add a JSP to the context.

Parameters:
  `jspName` - The servlet name under which this JSP file should be registered
  `jspFile` - The path, relative to the web application root, for the JSP file to be used for this servlet
Returns:
  a `ServletRegistration.Dynamic` object that can be used to further configure the servlet
Since:
  Servlet 4.0

### createServlet

<T extends Servlet> T createServlet(Class<T> c) throws ServletException
Create an Servlet instance using the given class. The instance is just created. No initialisation occurs.

Type Parameters:
  `T` - The type for the given class
Parameters:
  `c` - The the class for which an instance should be created
Returns:
  The created Servlet instance.
Throws:
  `ServletException` - If the servlet instance cannot be created.
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### getServletRegistration

ServletRegistration getServletRegistration(String servletName)
Obtain the details of the named servlet.

Parameters:
  `servletName` - The name of the Servlet of interest
Returns:
  The registration details for the named Servlet or `null` if no Servlet has been registered with the given name
Throws:
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### getServletRegistrations

Map<String, ? extends ServletRegistration> getServletRegistrations()
Obtain a Map of servlet names to servlet registrations for all servlets registered with this context.

Returns:
  A Map of servlet names to servlet registrations for all servlets registered with this context
Throws:
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### addFilter

FilterRegistration.Dynamic addFilter(String filterName, String className)
Add filter to context.

Parameters:
  `filterName` - Name of filter to add
  `className` - Name of filter class
Returns:
  `null` if the filter has already been fully defined, else a `FilterRegistration.Dynamic` object that can be used to further configure the filter
Throws:
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
  `IllegalStateException` - If the context has already been initialised
Since:
  Servlet 3.0

### addFilter

FilterRegistration.Dynamic addFilter(String filterName, Filter filter)
Add filter to context.

Parameters:
  `filterName` - Name of filter to add
  `filter` - Filter to add
Returns:
  `null` if the filter has already been fully defined, else a `FilterRegistration.Dynamic` object that can be used to further configure the filter
Throws:
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
  `IllegalStateException` - If the context has already been initialised
Since:
  Servlet 3.0

### addFilter

FilterRegistration.Dynamic addFilter(String filterName, Class<? extends Filter> filterClass)
Add filter to context.

Parameters:
  `filterName` - Name of filter to add
  `filterClass` - Class of filter to add
Returns:
  `null` if the filter has already been fully defined, else a `FilterRegistration.Dynamic` object that can be used to further configure the filter
Throws:
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
  `IllegalStateException` - If the context has already been initialised
Since:
  Servlet 3.0

### createFilter

<T extends Filter> T createFilter(Class<T> c) throws ServletException
Create a Filter instance using the given class. The instance is just created. No initialisation occurs.

Type Parameters:
  `T` - The type for the given class
Parameters:
  `c` - The the class for which an instance should be created
Returns:
  The created Filter instance.
Throws:
  `ServletException` - If the Filter instance cannot be created
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### getFilterRegistration

FilterRegistration getFilterRegistration(String filterName)
Returns the `FilterRegistration` for the given filter, or `null` if no such filter exists.

Parameters:
  `filterName` - The name of the filter for which to return the registration
Returns:
  The `FilterRegistration` for the given filter, or `null` if no such filter exists
Throws:
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### getFilterRegistrations

Map<String, ? extends FilterRegistration> getFilterRegistrations()
Returns an immutable Map of all the filter registrations for this web application, where the key is the filter name and the value is the `FilterRegistration` object.

Returns:
  An immutable Map of all the filter registrations for this web application
Throws:
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### getSessionCookieConfig

SessionCookieConfig getSessionCookieConfig()
Returns the `SessionCookieConfig` object for this web application, which can be used to configure the session tracking cookie.

Returns:
  The `SessionCookieConfig` object for this web application
Throws:
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### setSessionTrackingModes

void setSessionTrackingModes(Set<SessionTrackingMode> sessionTrackingModes)
Configures the available session tracking modes for this web application.

Parameters:
  `sessionTrackingModes` - The session tracking modes to use for this web application
Throws:
  `IllegalArgumentException` - If sessionTrackingModes specifies `SessionTrackingMode.SSL` in combination with any other `SessionTrackingMode`
  `IllegalStateException` - If the context has already been initialised
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### getDefaultSessionTrackingModes

Set<SessionTrackingMode> getDefaultSessionTrackingModes()
Obtains the default session tracking modes for this web application. By default `SessionTrackingMode.URL` is always supported, `SessionTrackingMode.COOKIE` is supported unless the `cookies` attribute has been set to `false` for the context and `SessionTrackingMode.SSL` is supported if at least one of the connectors used by this context has the attribute `secure` set to `true`.

Returns:
  The set of default session tracking modes for this web application
Since:
  Servlet 3.0

### getEffectiveSessionTrackingModes

Set<SessionTrackingMode> getEffectiveSessionTrackingModes()
Obtains the currently enabled session tracking modes for this web application.

Returns:
  The value supplied via `setSessionTrackingModes(Set)` if one was previously set, else return the defaults
Since:
  Servlet 3.0

### addListener

void addListener(String className)
Adds a listener to this web application. The listener instance will be created by the container using the no-argument constructor of the given class.

Parameters:
  `className` - The fully qualified class name of the listener to add
Throws:
  `ClassCastException` - If the class name does not implement `EventListener` or a subinterface recognized by the servlet container, or if a non-standard listener type is not packaged in a JAR file with a `listener` element in the `META-INF/services` directory
  `IllegalArgumentException` - If the lifecycle of a listener prohibits addition at runtime, or if the class has a `WebListener` annotation that conflicts with the programmatic addition
  `IllegalStateException` - If the context has already been initialised
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### addListener

<T extends EventListener> void addListener(T t)
Adds the given listener instance to this web application.

Type Parameters:
  `T` - The type of listener being added
Parameters:
  `t` - The listener instance to add
Throws:
  `ClassCastException` - If the class of the listener instance does not implement `EventListener` or a subinterface recognized by the servlet container, or if a non-standard listener type is not packaged in a JAR file with a `listener` element in the `META-INF/services` directory
  `IllegalArgumentException` - If the lifecycle of a listener prohibits addition at runtime, or if the class has a `WebListener` annotation that conflicts with the programmatic addition
  `IllegalStateException` - If the context has already been initialised
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### addListener

void addListener(Class<? extends EventListener> listenerClass)
Adds a listener to this web application. The listener instance will be created by the container using the no-argument constructor of the given class.

Parameters:
  `listenerClass` - The class of the listener to add
Throws:
  `ClassCastException` - If the class does not implement `EventListener` or a subinterface recognized by the servlet container, or if a non-standard listener type is not packaged in a JAR file with a `listener` element in the `META-INF/services` directory
  `IllegalArgumentException` - If the lifecycle of a listener prohibits addition at runtime, or if the class has a `WebListener` annotation that conflicts with the programmatic addition
  `IllegalStateException` - If the context has already been initialised
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### createListener

<T extends EventListener> T createListener(Class<T> c) throws ServletException
Creates a new instance of the given listener class, using the web application class loader.

Type Parameters:
  `T` - The type of listener being created
Parameters:
  `c` - The class of the listener to create
Returns:
  The new listener instance
Throws:
  `ServletException` - If the listener cannot be instantiated, e.g., if the class does not have a no-argument constructor, or if instantiation fails for any other reason
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
Since:
  Servlet 3.0

### getJspConfigDescriptor

JspConfigDescriptor getJspConfigDescriptor()
Returns the `JspConfigDescriptor` for this web application, which provides access to the JSP configuration elements such as taglib and jsp-property-group declarations.

Returns:
  The `JspConfigDescriptor` for this web application
Since:
  Servlet 3.0

### getClassLoader

ClassLoader getClassLoader()
Get the web application class loader associated with this ServletContext.

Returns:
  The associated web application class loader
Throws:
  `SecurityException` - if access to the class loader is prevented by a SecurityManager
Since:
  Servlet 3.0

### declareRoles

void declareRoles(String... roleNames)
Add to the declared roles for this ServletContext.

Parameters:
  `roleNames` - The roles to add
Throws:
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
  `IllegalArgumentException` - If the list of roleNames is null or empty
  `IllegalStateException` - If the ServletContext has already been initialised
Since:
  Servlet 3.0

### getVirtualServerName

String getVirtualServerName()
Get the primary name of the virtual host on which this context is deployed. The name may or may not be a valid host name.

Returns:
  The primary name of the virtual host on which this context is deployed
Since:
  Servlet 3.1

### getSessionTimeout

int getSessionTimeout()
Get the default session timeout.

Returns:
  The current default session timeout in minutes
Since:
  Servlet 4.0

### setSessionTimeout

void setSessionTimeout(int sessionTimeout)
Set the default session timeout. This method may only be called before the ServletContext is initialised.

Parameters:
  `sessionTimeout` - The new default session timeout in minutes.
Throws:
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
  `IllegalStateException` - If the ServletContext has already been initialised
Since:
  Servlet 4.0

### getRequestCharacterEncoding

String getRequestCharacterEncoding()
Get the default character encoding for reading request bodies.

Returns:
  The character encoding name or `null` if no default has been specified
Since:
  Servlet 4.0

### setRequestCharacterEncoding

void setRequestCharacterEncoding(String encoding)
Set the default character encoding to use for reading request bodies. Calling this method will over-ride any value set in the deployment descriptor.

Parameters:
  `encoding` - The name of the character encoding to use
Throws:
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
  `IllegalStateException` - If the ServletContext has already been initialised
Since:
  Servlet 4.0

### getResponseCharacterEncoding

String getResponseCharacterEncoding()
Get the default character encoding for writing response bodies.

Returns:
  The character encoding name or `null` if no default has been specified
Since:
  Servlet 4.0

### setResponseCharacterEncoding

void setResponseCharacterEncoding(String encoding)
Set the default character encoding to use for writing response bodies. Calling this method will over-ride any value set in the deployment descriptor.

Parameters:
  `encoding` - The name of the character encoding to use
Throws:
  `UnsupportedOperationException` - If called from a `ServletContextListener.contextInitialized(ServletContextEvent)` method of a `ServletContextListener` that was not defined in a web.xml file, a web-fragment.xml file nor annotated with `WebListener`. For example, a `ServletContextListener` defined in a TLD would not be able to use this method.
  `IllegalStateException` - If the ServletContext has already been initialised
Since:
  Servlet 4.0